---
name: 使用说明
route: /
---

## 通用组件库
> 项目中使用的通用组件
基于 antd ，进行再次封装的数据绑定通用组件

### 安装
 ```
$ npm install fan-standard-comp --save
 ```
 或
 ```
$ yarn add fan-standard-comp
 ```


### 更新日志

🔥组件  🆕 新增  🐞修复 🔔删除 💄优化  📝 🛠 
## 2.0.x
`2020-04-16`
- 🔥 StandardFilter
  - 🌟 新增 `initialValues` 设置表单控件组初始值，只有初始化以及重置时生效
  - 🌟 新增 `getFormFields` 获取表单字段值及表单实例
  - 🛠 formItemGroup API 
      - 🔔 弃用 `filedOptions`
      - 🌟 新增 `rules` 校验规则，设置字段的校验逻辑 (由原来的filedOptions.rules转到此处)
  - 💄 优化 `icon` 支持传 String 或 ReactNode （String显示图标功能待优化，未引入图标库）
- 🔥 RenderItemGroup
  - 🔔 弃用 `disabledAll` 改正使用  `fieldStatus='disabled'`
  - 🌟 新增 `fieldStatus` 表示当前控件正常操作、禁用、或仅显示文本
  - 🛠 ItemGroup API 
    - 💄 优化 `display` 可支持传对象，即当前标签与输入控件间的布局，如{labelCol:{span: 3}, wrapperCol: {span: 8}}
- 🔥 FieldComponent
  - 🔔 调整 `type` 表单控件类型接收值 🔔 弃用 `monthPicker`,` weekPicker`, `yearPicker`
  - 🔔 弃用 `disabledAll` 改正使用  `fieldStatus='disabled'`
  - 🌟 新增 `fieldStatus` 表示当前控件正常操作、禁用、或仅显示文本
- 🔥 RefactorTree
  - 🔔 调整 `onSelect` 参数字段：`onSelect(keys, selectData(如：{ currentData, multiData: multiCheckedData }), e)`
  - 🌟 新增 `onCheck` 参数字段：`onSelect(keys,selectData(如：{ currentData, multiData: multiCheckedData }), e)`
- StandardTable
  - 💄 优化 `columns 操作列`配置 `buttonGroup` 支持方法格式，返回数组进行渲染
- SpecIcon
  - 🔔 调整 `type`默认设置值为`colour`，使用svg格式，若使用字形图标则需配置 `type="font"`
  - 🔔 调整 `prefix`默认设置为`speci`，适用为基础图标使用，若是项目内，则会使用额外定义的prefix值
- StandardModal
  - 💄 优化 `getFormFields` 弹窗类型`type='form'` 时获取弹窗内表单字段值及表单实例
  - 🌟 新增 `initialValues` 设置弹窗内表单控件组初始值
  - 🛠 formItemGroup API 
     - 🔔 弃用 `filedOptions`
     - 🌟 新增 `rules` 校验规则，设置字段的校验逻辑 (由原来的filedOptions.rules转到此处)
  - 💄 优化 `icon` 支持传 String 或 ReactNode （String显示图标功能待优化，未引入图标库）
- formItemGroup （涉及：StandardModal、StandardFilter）表单渲染配置项更新
  - 💄 优化 `isHide`,支持使用方法返回，`isHide(fieldValues,form)`, fieldValues参数可获取当前表单内所有表单项的值
  - 🌟 新增 `type='tree-select`,下拉树选择添加表单处可显示完整层级名称字段 `showFullLevel`，并添加`separator` 配置其层级分割符，默认是`/`


## 2.0.4
`2020-04-28`
- FieldComponent
   - 修复 控件类型为`type=select`配置`labelInValue`下只读无法显示值
   - 修复 控件类型为`type=tree-select`,渲染数据异步请求时，值显示为空白
   - 新增 控件类型为`type=select`,新增配置项`selectOptionRender`,可自定义下拉选项展示内容
   
`2020-04-29`
- RefactorTree
  - 💄 修改  `optionName` 替换成原来字段名指定的  ` key 替换成 value`  `{ value: 'id', title: 'title', children: 'children' }`
- StandardTable
  - 💄 优化 `data.pagination=false`时，隐藏页码栏
