"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("antd/es/empty/style");

var _empty = _interopRequireDefault(require("antd/es/empty"));

require("antd/es/popconfirm/style");

var _popconfirm = _interopRequireDefault(require("antd/es/popconfirm"));

require("antd/es/icon/style");

var _icon = _interopRequireDefault(require("antd/es/icon"));

require("antd/es/tree/style");

var _tree = _interopRequireDefault(require("antd/es/tree"));

var _react = _interopRequireWildcard(require("react"));

var _index = _interopRequireDefault(require("../SpecIconFont/index"));

require("./index.less");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var TreeNode = _tree["default"].TreeNode;

var RefactorTree = function RefactorTree(props) {
  var treeData = props.treeData,
      rootName = props.rootName,
      rootKey = props.rootKey,
      rootIcon = props.rootIcon,
      emptyDescription = props.emptyDescription,
      _props$optionName = props.optionName,
      optionName = _props$optionName === void 0 ? {
    value: 'key',
    title: 'title',
    children: 'children',
    disabled: 'disabled'
  } : _props$optionName,
      defaultSelectedKeys = props.defaultSelectedKeys,
      nodeItemReset = props.nodeItemReset,
      nodeExtra = props.nodeExtra,
      _props$selectable = props.selectable,
      selectable = _props$selectable === void 0 ? true : _props$selectable,
      nodeControl = props.nodeControl,
      limitKey = props.limitKey,
      checkedKeys = props.checkedKeys,
      checkStrictly = props.checkStrictly,
      otherProps = _objectWithoutProperties(props, ["treeData", "rootName", "rootKey", "rootIcon", "emptyDescription", "optionName", "defaultSelectedKeys", "nodeItemReset", "nodeExtra", "selectable", "nodeControl", "limitKey", "checkedKeys", "checkStrictly"]); // 重新组合指定数据源字段 （limitKey：用于限制只能选择指定同一层级的数据）


  var _Object$assign = Object.assign({
    value: 'key',
    title: 'title',
    children: 'children',
    disabled: 'disabled'
  }, optionName),
      title = _Object$assign.title,
      value = _Object$assign.value,
      children = _Object$assign.children,
      disabled = _Object$assign.disabled;

  var _useState = (0, _react.useState)([]),
      _useState2 = _slicedToArray(_useState, 2),
      dataList = _useState2[0],
      setDataList = _useState2[1]; // 限制节点选中条件下更新列表数据


  var resetDataWithLimit = function resetDataWithLimit(hasKeys, list, resultList) {
    // 利用ID匹配对应选中的完整节点数据
    var filterCheckedNode = function filterCheckedNode(ids, preList, matchList) {
      if (Array.isArray(preList) && preList.length > 0) {
        preList.forEach(function (item, i) {
          if (ids.includes(item[value])) {
            matchList.push(_objectSpread({}, item));
          }

          filterCheckedNode(ids, item[children], matchList);
        });
      }
    }; // 筛选同一层级可选择，其他层级数据不可选择（限制按指定字段名的层级数据）


    var filterResetSameLevel = function filterResetSameLevel(preList, resData, matchData) {
      if (Array.isArray(preList) && preList.length > 0) {
        preList.forEach(function (item, i) {
          resData[i] = _objectSpread({}, item);
          resData[i].isLimit = item[limitKey] !== matchData; // [limitKey];

          var newDeepArr = [];
          filterResetSameLevel(item[children], newDeepArr, matchData);
          resData[i][children] = newDeepArr;
        });
      }
    };

    var matchItems = [];
    filterCheckedNode(hasKeys, list, matchItems); // 先筛选出来选中节点的数据，取其中的 level 层级的值(数据必须保证同级类型值一致)

    if (matchItems.length > 0) {
      filterResetSameLevel(list, resultList, matchItems[0][limitKey]);
    }
  };

  (0, _react.useEffect)(function () {
    // 有配置limitKey指定限制同级节点时，添加判断节点选择限制(在父子节点不相关联条件下使用checkStrictly=true)
    if (checkStrictly && limitKey && checkedKeys) {
      if (Array.isArray(checkedKeys) && checkedKeys.length > 0 || Array.isArray(checkedKeys.checked) && checkedKeys.checked.length > 0) {
        var resetList = [];
        resetDataWithLimit(checkedKeys.checked || checkedKeys, treeData, resetList);
        setDataList(resetList);
      } else {
        setDataList(treeData || []);
      }
    } else {
      setDataList(treeData || []); // 默认状态直接赋值传进来的数据
    }
  }, [treeData, checkedKeys]);

  var handleToSelectTreeNode = function handleToSelectTreeNode(key, e) {
    var onSelect = props.onSelect;
    var currentData = e.node.dataRef;
    var multiSelectedData = [];
    e.selectedNodes.map(function (item) {
      return multiSelectedData.push(item.dataRef);
    }); // 多选条件下,当前选中所有节点数据

    onSelect && onSelect(key, {
      currentData: currentData,
      multiData: multiSelectedData
    }, e);
  };

  var handleToCheckTreeNode = function handleToCheckTreeNode(keys, e) {
    var onCheck = props.onCheck;
    var currentData = e.node.dataRef;
    var multiCheckedData = [];
    e.checkedNodes.map(function (item) {
      return multiCheckedData.push(item.dataRef);
    }); // 多选条件下,当前选中所有节点数据

    onCheck && onCheck(keys, {
      currentData: currentData,
      multiData: multiCheckedData
    }, e);
  };

  var handleNodeControl = function handleNodeControl(e, type, nodeData) {
    e.stopPropagation();
    var onEdit = nodeControl.onEdit,
        onDelete = nodeControl.onDelete;

    if (type === 'edit') {
      onEdit && onEdit(nodeData);
    }

    if (type === 'delete') {
      onDelete && onDelete(nodeData);
    }
  }; // const <Icon type={selected ? 'frown' : 'frown-o'} />


  var renderNodeTitle = function renderNodeTitle(item) {
    return _react["default"].createElement(_react["default"].Fragment, null, nodeItemReset && nodeItemReset(item).icon || (item.icon ? _react["default"].createElement(_icon["default"], {
      type: item.icon
    }) : null), " ", item[title], nodeControl ? _react["default"].createElement("span", {
      className: "treeControl"
    }, _react["default"].createElement("a", {
      onClick: function onClick(e) {
        handleNodeControl(e, 'edit', item);
      }
    }, _react["default"].createElement(_index["default"], {
      type: 'edit'
    })), _react["default"].createElement(_popconfirm["default"], {
      placement: 'top',
      title: "\u786E\u5B9A\u8981\u5220\u9664\uFF1A".concat(item[title], "\u5417\uFF1F"),
      icon: _react["default"].createElement(_index["default"], {
        name: "question"
      }),
      onConfirm: function onConfirm(e) {
        handleNodeControl(e, 'delete', item);
      }
    }, _react["default"].createElement("a", {
      onClick: function onClick(e) {
        return e.stopPropagation();
      }
    }, _react["default"].createElement(_index["default"], {
      name: 'delete'
    })))) : null, nodeExtra && nodeExtra);
  };

  var renderTreeNodes = function renderTreeNodes(data) {
    return data.map(function (item) {
      if (item[children]) {
        return _react["default"].createElement(TreeNode, _extends({}, item, {
          title: renderNodeTitle(item),
          key: item[value],
          className: selectable ? '' : "notPointer",
          disabled: item.isLimit || nodeItemReset && nodeItemReset(item).disabled || item[disabled],
          dataRef: item
        }), renderTreeNodes(item[children]));
      }

      return _react["default"].createElement(TreeNode, _extends({}, item, {
        title: renderNodeTitle(item),
        key: item[value],
        className: selectable ? '' : "notPointer",
        disabled: item.isLimit || nodeItemReset && nodeItemReset(item).disabled || item[disabled],
        dataRef: item
      }));
    });
  };

  if (dataList.length == 0) return _react["default"].createElement(_empty["default"], {
    image: _empty["default"].PRESENTED_IMAGE_SIMPLE,
    description: emptyDescription
  });
  var defExpand = [];

  if (defaultSelectedKeys && defaultSelectedKeys.length > 0) {
    defExpand = defaultSelectedKeys;
  } else {
    defExpand = rootKey ? [rootKey] : ['0'];
  }

  return _react["default"].createElement(_tree["default"], _extends({
    // switcherIcon={<Icon type="down" />}
    defaultExpandedKeys: defExpand,
    defaultSelectedKeys: defaultSelectedKeys,
    selectable: selectable,
    checkedKeys: checkedKeys,
    checkStrictly: checkStrictly
  }, otherProps, {
    onSelect: handleToSelectTreeNode,
    onCheck: handleToCheckTreeNode
  }), rootName ? _react["default"].createElement(TreeNode, {
    title: rootName,
    key: rootKey || '0',
    className: selectable ? '' : "notPointer",
    icon: rootIcon || null
  }, renderTreeNodes(dataList)) : renderTreeNodes(dataList));
};

var _default = RefactorTree;
exports["default"] = _default;