"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("antd/es/upload/style");

var _upload = _interopRequireDefault(require("antd/es/upload"));

require("antd/es/button/style");

var _button = _interopRequireDefault(require("antd/es/button"));

require("antd/es/radio/style");

var _radio = _interopRequireDefault(require("antd/es/radio"));

require("antd/es/checkbox/style");

var _checkbox = _interopRequireDefault(require("antd/es/checkbox"));

require("antd/es/input-number/style");

var _inputNumber = _interopRequireDefault(require("antd/es/input-number"));

require("antd/es/date-picker/style");

var _datePicker = _interopRequireDefault(require("antd/es/date-picker"));

require("antd/es/select/style");

var _select = _interopRequireDefault(require("antd/es/select"));

require("antd/es/input/style");

var _input = _interopRequireDefault(require("antd/es/input"));

var _react = _interopRequireWildcard(require("react"));

var _moment = _interopRequireDefault(require("moment"));

var _index = _interopRequireDefault(require("../Uploader/index"));

var _index2 = _interopRequireDefault(require("../../SpecIconFont/index"));

var _RefactorTreeSelect = _interopRequireDefault(require("./RefactorTreeSelect.js"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var TextArea = _input["default"].TextArea,
    Password = _input["default"].Password;
var Option = _select["default"].Option;
var RangePicker = _datePicker["default"].RangePicker; // 表单组件类型

var FieldComponent = _react["default"].forwardRef(function (props, ref) {
  var type = props.type,
      onChange = props.onChange,
      value = props.value,
      style = props.style,
      placeholder = props.placeholder,
      protoConfig = props.protoConfig,
      _props$treeData = props.treeData,
      treeData = _props$treeData === void 0 ? [] : _props$treeData,
      filedName = props.filedName,
      _props$selectOptionNa = props.selectOptionName,
      selectOptionName = _props$selectOptionNa === void 0 ? {
    value: 'value',
    label: 'label',
    disabled: 'disabled'
  } : _props$selectOptionNa,
      _props$treeOptionName = props.treeOptionName,
      treeOptionName = _props$treeOptionName === void 0 ? {
    title: 'title',
    value: 'value',
    children: 'children'
  } : _props$treeOptionName,
      _props$fieldStatus = props.fieldStatus,
      fieldStatus = _props$fieldStatus === void 0 ? 'default' : _props$fieldStatus,
      showFullLevel = props.showFullLevel,
      separator = props.separator,
      selectOptionRender = props.selectOptionRender;
  var selectOptions = props.selectOptions;
  var compContent;

  if (selectOptionName && selectOptions) {
    // 将传值的数据进行转换
    selectOptions = selectOptions.map(function (item) {
      return _objectSpread({}, item, {
        value: item[selectOptionName.value || 'value'],
        label: item[selectOptionName.label || 'label'],
        disabled: item[selectOptionName.disabled || 'disabled']
      });
    });
  }

  var defaultProps = _objectSpread({
    style: style,
    onChange: onChange,
    value: value,
    ref: ref
  }, protoConfig);

  if (fieldStatus === 'disabled') {
    defaultProps.disabled = true;
  }

  var sortLimitRule = {}; // 排序字段长度限制

  if (filedName === 'sorts' || filedName === 'sort' || filedName === 'indexSort' || filedName === 'sorta' || filedName === 'categorySort') {
    sortLimitRule = {
      min: 0,
      max: 999999999
    };
  } // 设置纯展示模式下的下拉、单选、多选表单值


  var setSelectValue = function setSelectValue(value) {
    var labelInValue = defaultProps.labelInValue;
    if (!value || !selectOptions) return '-'; // 无值情况 下
    // 数组情况

    if (Array.isArray(value)) {
      var matchValues = [];
      value.forEach(function (valKey) {
        var matchValue = selectOptions.filter(function (seItem) {
          return seItem[selectOptionName.value] === valKey;
        });

        if (matchValue.length > 0) {
          matchValues.push(matchValue[0].label);
        }
      });
      return matchValues.join(',');
    } else {
      // 如select配置labelInValue则value返回数据是对象{key: 'xxx'}
      var matchValue = selectOptions.filter(function (seItem) {
        return seItem[selectOptionName.value] === (labelInValue ? value.key : value);
      }); // 如果 select 配置选项展示内容，则直接使用其配置值展示当前只读信息

      if (selectOptionRender) {
        return matchValue.length > 0 ? selectOptionRender(matchValue[0]) : '-';
      }

      return matchValue.length > 0 ? matchValue[0].label : '-';
    }
  }; // 设置纯展示模式下的日期控件值


  var setDatePickerValue = function setDatePickerValue(value) {
    if (!value) return '-'; // 无值情况 下
    // 数组情况 'YYYY-MM-DD HH:mm:ss' : 'YYYY-MM-DD'

    switch (type) {
      case 'datePicker':
        return (0, _moment["default"])(value).format(protoConfig && protoConfig.format || 'YYYY-MM-DD');
        break;

      case 'dateTimePicker':
        return (0, _moment["default"])(value).format(protoConfig && protoConfig.format || 'YYYY-MM-DD HH:mm:ss');
        break;

      case 'rangePicker':
        return "".concat((0, _moment["default"])(value[0]).format(protoConfig && protoConfig.format || 'YYYY-MM-DD'), " - ").concat((0, _moment["default"])(value[1]).format(protoConfig && protoConfig.format || 'YYYY-MM-DD'));
        break;

      case 'rangeTimePicker':
        return "".concat((0, _moment["default"])(value[0]).format(protoConfig && protoConfig.format || 'YYYY-MM-DD  HH:mm:ss'), " - ").concat((0, _moment["default"])(value[1]).format(protoConfig && protoConfig.format || 'YYYY-MM-DD  HH:mm:ss'));
        break;

      case 'monthPicker':
        return (0, _moment["default"])(value).format(protoConfig && protoConfig.format || 'MM月');
        break;

      default:
        return '-';
        break;
    }
  }; // 设置纯展示模式下上传控件显示值


  var setUploaderValue = function setUploaderValue(value) {
    console.log('value', value);
    if (!value) return '-'; // 无值情况 下

    return _react["default"].createElement("div", {
      className: "spec-uploader-viewonly"
    }, _react["default"].createElement("img", {
      className: "ant-upload-list-item-image",
      src: value
    }));
  }; // 设置纯展示模式下的“下拉树”控件返回值


  var viewOnly = fieldStatus === 'viewOnly'; // 是否纯展示

  switch (type) {
    case 'input':
      compContent = viewOnly ? value || '-' : _react["default"].createElement(_input["default"], _extends({
        placeholder: fieldStatus === 'disabled' ? '' : defaultProps.placeholder || placeholder || '请输入',
        autoComplete: "off",
        maxLength: defaultProps.maxLength || 50
      }, defaultProps));
      break;

    case 'password':
      compContent = viewOnly ? value || '-' : _react["default"].createElement(Password, _extends({
        autoComplete: "off",
        placeholder: fieldStatus === 'disabled' ? '' : defaultProps.placeholder || placeholder || '请输入',
        maxLength: defaultProps.maxLength || 50
      }, defaultProps));
      break;

    case 'textarea':
      compContent = viewOnly ? value || '-' : _react["default"].createElement(TextArea, _extends({
        placeholder: fieldStatus === 'disabled' ? '' : defaultProps.placeholder || placeholder || '请输入',
        maxLength: defaultProps.maxLength || 500
      }, defaultProps));
      break;

    case 'inputNumber':
      compContent = viewOnly ? value || 0 : _react["default"].createElement(_inputNumber["default"], _extends({
        placeholder: fieldStatus === 'disabled' ? '' : defaultProps.placeholder || placeholder || '请输入数字'
      }, sortLimitRule, defaultProps));
      break;

    case 'select':
      compContent = viewOnly ? setSelectValue(value) : _react["default"].createElement(_select["default"], _extends({
        allowClear: true,
        placeholder: fieldStatus === 'disabled' ? '' : defaultProps.placeholder || placeholder || "".concat(defaultProps.showSearch ? '请输入选择' : '请选择'),
        filterOption: function filterOption(input, option) {
          return defaultProps.showSearch ? option.props.children.toLowerCase().indexOf(input.toLowerCase()) >= 0 : false;
        }
      }, defaultProps), selectOptions.map(function (val) {
        return _react["default"].createElement(Option, {
          value: val.value,
          key: val.value,
          disabled: val.disabled
        }, selectOptionRender ? selectOptionRender(val) : val.label);
      }));
      break;

    case 'tree-select':
      compContent = _react["default"].createElement(_RefactorTreeSelect["default"], _extends({
        treeData: treeData,
        treeOptionName: treeOptionName,
        allowClear: true,
        separator: separator,
        showFullLevel: showFullLevel,
        placeholder: fieldStatus === 'disabled' ? '' : defaultProps.placeholder || placeholder || '请选择',
        protoTreeNode: protoConfig && protoConfig.TreeNode,
        fieldStatus: fieldStatus
      }, defaultProps));
      break;

    case 'checkbox':
      compContent = viewOnly ? setSelectValue(value) : _react["default"].createElement(_checkbox["default"].Group, _extends({
        options: selectOptions
      }, defaultProps, {
        style: _objectSpread({
          width: 'auto'
        }, defaultProps.style)
      }));
      break;

    case 'radio':
      compContent = viewOnly ? setSelectValue(value) : _react["default"].createElement(_radio["default"].Group, _extends({
        options: selectOptions
      }, defaultProps, {
        style: _objectSpread({
          width: 'auto'
        }, defaultProps.style)
      }));
      break;

    case 'datePicker': // 使用配置 picker设置其属于week,month,year

    case 'dateTimePicker':
      compContent = viewOnly ? setDatePickerValue(value) : _react["default"].createElement(_datePicker["default"], _extends({
        showTime: defaultProps.showTime || type === 'dateTimePicker',
        placeholder: fieldStatus === 'disabled' ? '' : defaultProps.placeholder || placeholder || '请选择'
      }, defaultProps, {
        style: _objectSpread({
          'minWidth': 'auto'
        }, defaultProps.style)
      }));
      break;

    case 'rangePicker':
    case 'rangeTimePicker':
      compContent = viewOnly ? setDatePickerValue(value) : _react["default"].createElement(RangePicker, _extends({
        showTime: defaultProps.showTime || type === 'rangeTimePicker'
      }, defaultProps, {
        style: _objectSpread({
          width: type === 'rangeTimePicker' ? 'auto' : '100%'
        }, defaultProps.style)
      }));
      break;

    case 'upload':
      compContent = _react["default"].createElement(_upload["default"], defaultProps, defaultProps.fileList && defaultProps.fileList.length >= 1 || defaultProps.defaultFileList && defaultProps.defaultFileList.length >= 1 ? null : _react["default"].createElement(_button["default"], null, _react["default"].createElement(_index2["default"], {
        name: "upload"
      }), " \u70B9\u51FB\u4E0A\u4F20"));
      break;

    case 'uploader':
      compContent = viewOnly ? setUploaderValue(value) : _react["default"].createElement(_index["default"], defaultProps); // compContent = <Uploader {...defaultProps}></Uploader>

      break;

    case 'custom':
      compContent = defaultProps.customRender && defaultProps.customRender(props) || null;
      break;

    default:
      compContent = null;
      break;
  }

  return compContent;
});

var _default = FieldComponent;
exports["default"] = _default;