---
menu: 数据展示
name: SpecIcon 图标
---

# 图标组件


### 基本图标用法 
	import { SpecIcon } from 'fan-standard-comp';
	<SpecIcon name="user"/>

### 基本图标使用字形显示

	
    <SpecIcon name="user" type="font"/>


### 扩展图标使用
`prefix`前缀配置值根据项目内引入的新图标库前缀为准
	
    <SpecIcon name="user" prefix="sub"/>


## API
| 参数      | 说明                                      | 类型         | 默认值 |
|----------|------------------------------------------|-------------|-------|
| type | 图标展示源(默认colour，默认是使用SVG展示，如果要使用字形显示则配置 type="font") | String | "colour" |
| prefix | 图标类名前缀(默认speci指基础图标，若项目内业务图标，则会另外定义 ) | String | 'speci' |
| name | 图标类名 | String | - |
| size | 设置图标大小 | String | - |
| style | 设置样式 | Object | - |
| status | 图标状态色（按样式默认指定几种类型颜色） | String | - |

